// Copyright (c) 1994 James Clark
// See the file COPYING for copying permission.

#ifndef CopyOwner_INCLUDED
#define CopyOwner_INCLUDED 1

#include "Owner.H"

template<class T>
class CopyOwner : public Owner<T> {
public:
  CopyOwner() { }
  CopyOwner(T *p) : Owner<T>(p) { }
  CopyOwner(const CopyOwner<T> &);
  void operator=(const CopyOwner<T> &o);
  void operator=(T *p) { Owner<T>::operator=(p); }
  void destruct() { this->CopyOwner<T>::~CopyOwner(); }
};

#ifdef DEFINE_TEMPLATES
#include "CopyOwner.C"
#endif

#endif /* not CopyOwner_INCLUDED */
