// Copyright (c) 1994 James Clark
// See the file COPYING for copying permission.


template<class T, class K, class HF, class KF>
OwnerTable<T, K, HF, KF>::OwnerTable()
{
}

template<class T, class K, class HF, class KF>
OwnerTable<T, K, HF, KF>::~OwnerTable()
{
  for (size_t i = 0; i < vec_.length(); i++)
    delete vec_[i];
}

template<class T, class K, class HF, class KF>
void OwnerTable<T, K, HF, KF>::clear()
{
  for (size_t i = 0; i < vec_.length(); i++)
    delete vec_[i];
  PointerTable<T *, K, HF, KF>::clear();
}

#if 0
template<class T, class K, class HF, class KF>
OwnerTable<T, K, HF, KF>::OwnerTable(const OwnerTable<T, K, HF, KF> &t)
: PointerTable<T *, K, HF, KF>(t)
{
  for (size_t i = 0; i < vec_.length(); i++)
    if (vec_[i])
      vec_[i] = new T(*vec_[i]);
}

template<class T, class K, class HF, class KF>
OwnerTable<T, K, HF, KF> &
OwnerTable<T, K, HF, KF>::operator=(const OwnerTable<T, K, HF, KF> &t)
{
  *(PointerTable<T *, K, HF, KF> *)this = t;
  for (size_t i = 0; i < vec_.length(); i++)
    if (vec_[i])
      vec_[i] = new T(*vec_[i]);
  return *this;
}
#endif

template<class T, class K, class HF, class KF>
void OwnerTable<T, K, HF, KF>::moveTo(OwnerTable<T, K, HF, KF> &to)
{
  to.clear();
  PointerTable<T *, K, HF, KF>::moveTo(to);
}
