// Copyright (c) 1994 James Clark
// See the file COPYING for copying permission.

#ifdef __GNUG__
#ifndef MANUAL_INST
#define MANUAL_INST
#endif
#endif

#ifdef MANUAL_INST

#define DEFINE_TEMPLATES
#include "Owner.H"
#include "CopyOwner.H"
#include "Vector.H"
#include "CopyVector.H"
#include "GrowableVectorD.H"
#include "CopyGrowableVectorD.H"
#include "GrowableVector.H"
#include "ResourcePointer.H"
#include "IList.H"
#include "IQueue.H"
#include "ISet.H"
#include "List.H"
#include "OwnerTable.H"
#include "PointerTable.H"
#include "HashTable.H"
#include "HashTableItemBase.H"
#include "String.H"
#include "RangeMap.H"
#include "SubstTable.H"
#include "XcharMap.H"
#include "IListIter.H"
#include "ISetIter.H"
#include "ListIter.H"
#undef DEFINE_TEMPLATES

#include <stddef.h>
#include "Attribute.H"
#include "Attributed.H"
#include "CharsetDecl.H"
#include "ContentToken.H"
#include "Dtd.H"
#include "ElementType.H"
#include "Entity.H"
#include "EquivClass.H"
#include "Event.H"
#include "Hash.H"
#include "HashTable.H"
#include "HashTableItemBase.H"
#include "InputSource.H"
#include "LinkProcess.H"
#include "Lpd.H"
#include "LpdEntityRef.H"
#include "Location.H"
#include "MessageArg.H"
#include "NamedResourceTable.H"
#include "NamedResource.H"
#include "NamedTable.H"
#include "Named.H"
#include "NameToken.H"
#include "OpenElement.H"
#include "OutputState.H"
#include "Recognizer.H"
#include "Sd.H"
#include "SdFormalError.H"
#include "SrInfo.H"
#include "StringResource.H"
#include "Syntax.H"
#include "Text.H"
#include "Trie.H"
#include "Undo.H"
#include "Boolean.H"
#include "types.H"
#include "Id.H"
#include "setAll.H"


#ifdef __DECCXX
#pragma define_template ConstResourcePointer<Notation>
#else
#ifdef ANSI_INST
template class ConstResourcePointer<Notation>;
#else
typedef ConstResourcePointer<Notation> Dummy_0;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ConstResourcePointer<Recognizer>
#else
#ifdef ANSI_INST
template class ConstResourcePointer<Recognizer>;
#else
typedef ConstResourcePointer<Recognizer> Dummy_1;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ConstResourcePointer<EntityOrigin>
#else
#ifdef ANSI_INST
template class ConstResourcePointer<EntityOrigin>;
#else
typedef ConstResourcePointer<EntityOrigin> Dummy_2;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ConstResourcePointer<NamedResource>
#else
#ifdef ANSI_INST
template class ConstResourcePointer<NamedResource>;
#else
typedef ConstResourcePointer<NamedResource> Dummy_3;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ResourcePointer<NamedResource>
#else
#ifdef ANSI_INST
template class ResourcePointer<NamedResource>;
#else
typedef ResourcePointer<NamedResource> Dummy_4;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ConstResourcePointer<AttributeValue>
#else
#ifdef ANSI_INST
template class ConstResourcePointer<AttributeValue>;
#else
typedef ConstResourcePointer<AttributeValue> Dummy_5;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ConstResourcePointer<ElementDefinition>
#else
#ifdef ANSI_INST
template class ConstResourcePointer<ElementDefinition>;
#else
typedef ConstResourcePointer<ElementDefinition> Dummy_6;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ConstResourcePointer<AttributeDefinitionList>
#else
#ifdef ANSI_INST
template class ConstResourcePointer<AttributeDefinitionList>;
#else
typedef ConstResourcePointer<AttributeDefinitionList> Dummy_7;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ConstResourcePointer<SharedXcharMap<PackedBoolean> >
#else
#ifdef ANSI_INST
template class ConstResourcePointer<SharedXcharMap<PackedBoolean> >;
#else
typedef ConstResourcePointer<SharedXcharMap<PackedBoolean> > Dummy_8;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ConstResourcePointer<SharedXcharMap<unsigned char> >
#else
#ifdef ANSI_INST
template class ConstResourcePointer<SharedXcharMap<unsigned char> >;
#else
typedef ConstResourcePointer<SharedXcharMap<unsigned char> > Dummy_9;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ConstResourcePointer<StringResource<Char> >
#else
#ifdef ANSI_INST
template class ConstResourcePointer<StringResource<Char> >;
#else
typedef ConstResourcePointer<StringResource<Char> > Dummy_10;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ConstResourcePointer<Sd>
#else
#ifdef ANSI_INST
template class ConstResourcePointer<Sd>;
#else
typedef ConstResourcePointer<Sd> Dummy_11;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ConstResourcePointer<Dtd>
#else
#ifdef ANSI_INST
template class ConstResourcePointer<Dtd>;
#else
typedef ConstResourcePointer<Dtd> Dummy_12;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ConstResourcePointer<Entity>
#else
#ifdef ANSI_INST
template class ConstResourcePointer<Entity>;
#else
typedef ConstResourcePointer<Entity> Dummy_13;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ConstResourcePointer<Origin>
#else
#ifdef ANSI_INST
template class ConstResourcePointer<Origin>;
#else
typedef ConstResourcePointer<Origin> Dummy_14;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ConstResourcePointer<Syntax>
#else
#ifdef ANSI_INST
template class ConstResourcePointer<Syntax>;
#else
typedef ConstResourcePointer<Syntax> Dummy_15;
#endif
#endif
#ifdef __DECCXX
#pragma define_template CopyGrowableVectorD<Attribute>
#else
#ifdef ANSI_INST
template class CopyGrowableVectorD<Attribute>;
#else
typedef CopyGrowableVectorD<Attribute> Dummy_16;
#endif
#endif
#ifdef __DECCXX
#pragma define_template CopyGrowableVectorD<TextItem>
#else
#ifdef ANSI_INST
template class CopyGrowableVectorD<TextItem>;
#else
typedef CopyGrowableVectorD<TextItem> Dummy_17;
#endif
#endif
#ifdef __DECCXX
#pragma define_template CopyOwner<BlankTrie>
#else
#ifdef ANSI_INST
template class CopyOwner<BlankTrie>;
#else
typedef CopyOwner<BlankTrie> Dummy_18;
#endif
#endif
#ifdef __DECCXX
#pragma define_template CopyOwner<AttributeSpec>
#else
#ifdef ANSI_INST
template class CopyOwner<AttributeSpec>;
#else
typedef CopyOwner<AttributeSpec> Dummy_19;
#endif
#endif
#ifdef __DECCXX
#pragma define_template CopyOwner<AttributeSemantics>
#else
#ifdef ANSI_INST
template class CopyOwner<AttributeSemantics>;
#else
typedef CopyOwner<AttributeSemantics> Dummy_20;
#endif
#endif
#ifdef __DECCXX
#pragma define_template VectorBase<char>
#else
#ifdef ANSI_INST
template class VectorBase<char>;
#else
typedef VectorBase<char> Dummy_21;
#endif
#endif
#ifdef __DECCXX
#pragma define_template CopyVector<char>
#else
#ifdef ANSI_INST
template class CopyVector<char>;
#else
typedef CopyVector<char> Dummy_22;
#endif
#endif
#ifdef __DECCXX
#pragma define_template CopyVector<ConstResourcePointer<Entity> >
#else
#ifdef ANSI_INST
template class CopyVector<ConstResourcePointer<Entity> >;
#else
typedef CopyVector<ConstResourcePointer<Entity> > Dummy_23;
#endif
#endif
#ifdef __DECCXX
#pragma define_template CopyVector<PackedBoolean>
#else
#ifdef ANSI_INST
template class CopyVector<PackedBoolean>;
#else
typedef CopyVector<PackedBoolean> Dummy_24;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVectorD<Attribute>
#else
#ifdef ANSI_INST
template class GrowableVectorD<Attribute>;
#else
typedef GrowableVectorD<Attribute> Dummy_25;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVectorD<TextItem>
#else
#ifdef ANSI_INST
template class GrowableVectorD<TextItem>;
#else
typedef GrowableVectorD<TextItem> Dummy_26;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVectorD<NameToken>
#else
#ifdef ANSI_INST
template class GrowableVectorD<NameToken>;
#else
typedef GrowableVectorD<NameToken> Dummy_27;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVectorD<CharsetDeclRange>
#else
#ifdef ANSI_INST
template class GrowableVectorD<CharsetDeclRange>;
#else
typedef GrowableVectorD<CharsetDeclRange> Dummy_28;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVectorD<String<Char> >
#else
#ifdef ANSI_INST
template class GrowableVectorD<String<Char> >;
#else
typedef GrowableVectorD<String<Char> > Dummy_29;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVectorD<CharsetDeclSection>
#else
#ifdef ANSI_INST
template class GrowableVectorD<CharsetDeclSection>;
#else
typedef GrowableVectorD<CharsetDeclSection> Dummy_30;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVectorD<Owner<ContentToken> >
#else
#ifdef ANSI_INST
template class GrowableVectorD<Owner<ContentToken> >;
#else
typedef GrowableVectorD<Owner<ContentToken> > Dummy_31;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVectorD<ConstResourcePointer<Dtd> >
#else
#ifdef ANSI_INST
template class GrowableVectorD<ConstResourcePointer<Dtd> >;
#else
typedef GrowableVectorD<ConstResourcePointer<Dtd> > Dummy_32;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVectorD<Owner<AttributeDefinition> >
#else
#ifdef ANSI_INST
template class GrowableVectorD<Owner<AttributeDefinition> >;
#else
typedef GrowableVectorD<Owner<AttributeDefinition> > Dummy_33;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVectorD<Owner<AttributeList> >
#else
#ifdef ANSI_INST
template class GrowableVectorD<Owner<AttributeList> >;
#else
typedef GrowableVectorD<Owner<AttributeList> > Dummy_34;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVectorD<ConstResourcePointer<ElementDefinition> >
#else
#ifdef ANSI_INST
template class GrowableVectorD<ConstResourcePointer<ElementDefinition> >;
#else
typedef GrowableVectorD<ConstResourcePointer<ElementDefinition> > Dummy_35;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVectorD<Text>
#else
#ifdef ANSI_INST
template class GrowableVectorD<Text>;
#else
typedef GrowableVectorD<Text> Dummy_36;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVector<ContentModelAmbiguity>
#else
#ifdef ANSI_INST
template class GrowableVector<ContentModelAmbiguity>;
#else
typedef GrowableVector<ContentModelAmbiguity> Dummy_37;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVector<Transition>
#else
#ifdef ANSI_INST
template class GrowableVector<Transition>;
#else
typedef GrowableVector<Transition> Dummy_38;
#endif
#endif
#ifdef __DECCXX
#pragma define_template VectorBase<LeafContentToken*>
#else
#ifdef ANSI_INST
template class VectorBase<LeafContentToken*>;
#else
typedef VectorBase<LeafContentToken*> Dummy_39;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVector<LeafContentToken*>
#else
#ifdef ANSI_INST
template class GrowableVector<LeafContentToken*>;
#else
typedef GrowableVector<LeafContentToken*> Dummy_40;
#endif
#endif
#ifdef __DECCXX
#pragma define_template VectorBase<ISetRange<Char> >
#else
#ifdef ANSI_INST
template class VectorBase<ISetRange<Char> >;
#else
typedef VectorBase<ISetRange<Char> > Dummy_41;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVector<ISetRange<Char> >
#else
#ifdef ANSI_INST
template class GrowableVector<ISetRange<Char> >;
#else
typedef GrowableVector<ISetRange<Char> > Dummy_42;
#endif
#endif
#ifdef __DECCXX
#pragma define_template VectorBase<ISetRange<WideChar> >
#else
#ifdef ANSI_INST
template class VectorBase<ISetRange<WideChar> >;
#else
typedef VectorBase<ISetRange<WideChar> > Dummy_43;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVector<ISetRange<WideChar> >
#else
#ifdef ANSI_INST
template class GrowableVector<ISetRange<WideChar> >;
#else
typedef GrowableVector<ISetRange<WideChar> > Dummy_44;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVector<EntityOriginNamedCharRef>
#else
#ifdef ANSI_INST
template class GrowableVector<EntityOriginNamedCharRef>;
#else
typedef GrowableVector<EntityOriginNamedCharRef> Dummy_45;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVector<RangeMapRange<WideChar,UnivChar> >
#else
#ifdef ANSI_INST
template class GrowableVector<RangeMapRange<WideChar,UnivChar> >;
#else
typedef GrowableVector<RangeMapRange<WideChar,UnivChar> > Dummy_46;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVector<size_t>
#else
#ifdef ANSI_INST
template class GrowableVector<size_t>;
#else
typedef GrowableVector<size_t> Dummy_47;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVector<unsigned int>
#else
#ifdef ANSI_INST
template class GrowableVector<unsigned int>;
#else
typedef GrowableVector<unsigned int> Dummy_48;
#endif
#endif
#ifdef __DECCXX
#pragma define_template HashTableItemBase<String<Char> >
#else
#ifdef ANSI_INST
template class HashTableItemBase<String<Char> >;
#else
typedef HashTableItemBase<String<Char> > Dummy_49;
#endif
#endif
#ifdef __DECCXX
#pragma define_template HashTableItem<String<Char>, int>
#else
#ifdef ANSI_INST
template class HashTableItem<String<Char>, int>;
#else
typedef HashTableItem<String<Char>, int> Dummy_50;
#endif
#endif
#ifdef __DECCXX
#pragma define_template HashTable<String<Char>,int>
#else
#ifdef ANSI_INST
template class HashTable<String<Char>,int>;
#else
typedef HashTable<String<Char>,int> Dummy_51;
#endif
#endif
#ifdef __DECCXX
#pragma define_template HashTableItem<String<Char>,Char>
#else
#ifdef ANSI_INST
template class HashTableItem<String<Char>,Char>;
#else
typedef HashTableItem<String<Char>,Char> Dummy_52;
#endif
#endif
#ifdef __DECCXX
#pragma define_template HashTable<String<Char>,Char>
#else
#ifdef ANSI_INST
template class HashTable<String<Char>,Char>;
#else
typedef HashTable<String<Char>,Char> Dummy_53;
#endif
#endif
#ifdef __DECCXX
#pragma define_template IList<EquivClass>
#else
#ifdef ANSI_INST
template class IList<EquivClass>;
#else
typedef IList<EquivClass> Dummy_54;
#endif
#endif
#ifdef __DECCXX
#pragma define_template IList<InputSource>
#else
#ifdef ANSI_INST
template class IList<InputSource>;
#else
typedef IList<InputSource> Dummy_55;
#endif
#endif
#ifdef __DECCXX
#pragma define_template IList<OpenElement>
#else
#ifdef ANSI_INST
template class IList<OpenElement>;
#else
typedef IList<OpenElement> Dummy_56;
#endif
#endif
#ifdef __DECCXX
#pragma define_template IList<ElementEvent>
#else
#ifdef ANSI_INST
template class IList<ElementEvent>;
#else
typedef IList<ElementEvent> Dummy_57;
#endif
#endif
#ifdef __DECCXX
#pragma define_template IList<OutputStateLevel>
#else
#ifdef ANSI_INST
template class IList<OutputStateLevel>;
#else
typedef IList<OutputStateLevel> Dummy_58;
#endif
#endif
#ifdef __DECCXX
#pragma define_template IList<SdFormalError>
#else
#ifdef ANSI_INST
template class IList<SdFormalError>;
#else
typedef IList<SdFormalError> Dummy_59;
#endif
#endif
#ifdef __DECCXX
#pragma define_template IList<Undo>
#else
#ifdef ANSI_INST
template class IList<Undo>;
#else
typedef IList<Undo> Dummy_60;
#endif
#endif
#ifdef __DECCXX
#pragma define_template IQueue<MessageEvent>
#else
#ifdef ANSI_INST
template class IQueue<MessageEvent>;
#else
typedef IQueue<MessageEvent> Dummy_61;
#endif
#endif
#ifdef __DECCXX
#pragma define_template IQueue<Event>
#else
#ifdef ANSI_INST
template class IQueue<Event>;
#else
typedef IQueue<Event> Dummy_62;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ISet<Char>
#else
#ifdef ANSI_INST
template class ISet<Char>;
#else
typedef ISet<Char> Dummy_63;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ISet<WideChar>
#else
#ifdef ANSI_INST
template class ISet<WideChar>;
#else
typedef ISet<WideChar> Dummy_64;
#endif
#endif
#ifdef __DECCXX
#pragma define_template OwnerTable<HashTableItemBase<String<Char> >,String<Char>,Hash,HashTableKeyFunction<String<Char> > >
#else
#ifdef ANSI_INST
template class OwnerTable<HashTableItemBase<String<Char> >,String<Char>,Hash,HashTableKeyFunction<String<Char> > >;
#else
typedef OwnerTable<HashTableItemBase<String<Char> >,String<Char>,Hash,HashTableKeyFunction<String<Char> > > Dummy_65;
#endif
#endif
#ifdef __DECCXX
#pragma define_template OwnerTableIter<HashTableItemBase<String<Char> >, String<Char>, Hash, HashTableKeyFunction<String<Char> > >
#else
#ifdef ANSI_INST
template class OwnerTableIter<HashTableItemBase<String<Char> >, String<Char>, Hash, HashTableKeyFunction<String<Char> > >;
#else
typedef OwnerTableIter<HashTableItemBase<String<Char> >, String<Char>, Hash, HashTableKeyFunction<String<Char> > > Dummy_66;
#endif
#endif
#ifdef __DECCXX
#pragma define_template OwnerTable<Named,String<Char>,Hash,NamedTableKeyFunction>
#else
#ifdef ANSI_INST
template class OwnerTable<Named,String<Char>,Hash,NamedTableKeyFunction>;
#else
typedef OwnerTable<Named,String<Char>,Hash,NamedTableKeyFunction> Dummy_67;
#endif
#endif
#ifdef __DECCXX
#pragma define_template OwnerTableIter<Named,String<Char>,Hash,NamedTableKeyFunction>
#else
#ifdef ANSI_INST
template class OwnerTableIter<Named,String<Char>,Hash,NamedTableKeyFunction>;
#else
typedef OwnerTableIter<Named,String<Char>,Hash,NamedTableKeyFunction> Dummy_68;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Owner<AndInfo>
#else
#ifdef ANSI_INST
template class Owner<AndInfo>;
#else
typedef Owner<AndInfo> Dummy_69;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Owner<BlankTrie>
#else
#ifdef ANSI_INST
template class Owner<BlankTrie>;
#else
typedef Owner<BlankTrie> Dummy_70;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Owner<EquivClass>
#else
#ifdef ANSI_INST
template class Owner<EquivClass>;
#else
typedef Owner<EquivClass> Dummy_71;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Owner<MessageArg>
#else
#ifdef ANSI_INST
template class Owner<MessageArg>;
#else
typedef Owner<MessageArg> Dummy_72;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Owner<ModelGroup>
#else
#ifdef ANSI_INST
template class Owner<ModelGroup>;
#else
typedef Owner<ModelGroup> Dummy_73;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Owner<OpenElement>
#else
#ifdef ANSI_INST
template class Owner<OpenElement>;
#else
typedef Owner<OpenElement> Dummy_74;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Owner<ContentToken>
#else
#ifdef ANSI_INST
template class Owner<ContentToken>;
#else
typedef Owner<ContentToken> Dummy_75;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Owner<ExternalInfo>
#else
#ifdef ANSI_INST
template class Owner<ExternalInfo>;
#else
typedef Owner<ExternalInfo> Dummy_76;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Owner<AttributeSpec>
#else
#ifdef ANSI_INST
template class Owner<AttributeSpec>;
#else
typedef Owner<AttributeSpec> Dummy_77;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Owner<DeclaredValue>
#else
#ifdef ANSI_INST
template class Owner<DeclaredValue>;
#else
typedef Owner<DeclaredValue> Dummy_78;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Owner<LeafContentToken>
#else
#ifdef ANSI_INST
template class Owner<LeafContentToken>;
#else
typedef Owner<LeafContentToken> Dummy_79;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Owner<AttributeSemantics>
#else
#ifdef ANSI_INST
template class Owner<AttributeSemantics>;
#else
typedef Owner<AttributeSemantics> Dummy_80;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Owner<CompiledModelGroup>
#else
#ifdef ANSI_INST
template class Owner<CompiledModelGroup>;
#else
typedef Owner<CompiledModelGroup> Dummy_81;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Owner<AttributeDefinition>
#else
#ifdef ANSI_INST
template class Owner<AttributeDefinition>;
#else
typedef Owner<AttributeDefinition> Dummy_82;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Owner<AttributeList>
#else
#ifdef ANSI_INST
template class Owner<AttributeList>;
#else
typedef Owner<AttributeList> Dummy_83;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Owner<Trie>
#else
#ifdef ANSI_INST
template class Owner<Trie>;
#else
typedef Owner<Trie> Dummy_84;
#endif
#endif
#ifdef __DECCXX
#pragma define_template PointerTableIter<Named*,String<Char>,Hash,NamedTableKeyFunction>
#else
#ifdef ANSI_INST
template class PointerTableIter<Named*,String<Char>,Hash,NamedTableKeyFunction>;
#else
typedef PointerTableIter<Named*,String<Char>,Hash,NamedTableKeyFunction> Dummy_85;
#endif
#endif
#ifdef __DECCXX
#pragma define_template PointerTable<HashTableItemBase<String<Char> >*,String<Char>,Hash,HashTableKeyFunction<String<Char> > >
#else
#ifdef ANSI_INST
template class PointerTable<HashTableItemBase<String<Char> >*,String<Char>,Hash,HashTableKeyFunction<String<Char> > >;
#else
typedef PointerTable<HashTableItemBase<String<Char> >*,String<Char>,Hash,HashTableKeyFunction<String<Char> > > Dummy_86;
#endif
#endif
#ifdef __DECCXX
#pragma define_template PointerTableIter<HashTableItemBase<String<Char> > *, String<Char>, Hash, HashTableKeyFunction<String<Char> > >
#else
#ifdef ANSI_INST
template class PointerTableIter<HashTableItemBase<String<Char> > *, String<Char>, Hash, HashTableKeyFunction<String<Char> > >;
#else
typedef PointerTableIter<HashTableItemBase<String<Char> > *, String<Char>, Hash, HashTableKeyFunction<String<Char> > > Dummy_87;
#endif
#endif
#ifdef __DECCXX
#pragma define_template PointerTable<Named*,String<Char>,Hash,NamedTableKeyFunction>
#else
#ifdef ANSI_INST
template class PointerTable<Named*,String<Char>,Hash,NamedTableKeyFunction>;
#else
typedef PointerTable<Named*,String<Char>,Hash,NamedTableKeyFunction> Dummy_88;
#endif
#endif
#ifdef __DECCXX
#pragma define_template PointerTable<ResourcePointer<NamedResource>,String<Char>,Hash,NamedResourceKeyFunction>
#else
#ifdef ANSI_INST
template class PointerTable<ResourcePointer<NamedResource>,String<Char>,Hash,NamedResourceKeyFunction>;
#else
typedef PointerTable<ResourcePointer<NamedResource>,String<Char>,Hash,NamedResourceKeyFunction> Dummy_89;
#endif
#endif
#ifdef __DECCXX
#pragma define_template PointerTableIter<ResourcePointer<NamedResource>,String<Char>,Hash,NamedResourceKeyFunction>
#else
#ifdef ANSI_INST
template class PointerTableIter<ResourcePointer<NamedResource>,String<Char>,Hash,NamedResourceKeyFunction>;
#else
typedef PointerTableIter<ResourcePointer<NamedResource>,String<Char>,Hash,NamedResourceKeyFunction> Dummy_90;
#endif
#endif
#ifdef __DECCXX
#pragma define_template RangeMapIter<WideChar,UnivChar>
#else
#ifdef ANSI_INST
template class RangeMapIter<WideChar,UnivChar>;
#else
typedef RangeMapIter<WideChar,UnivChar> Dummy_91;
#endif
#endif
#ifdef __DECCXX
#pragma define_template RangeMap<WideChar,UnivChar>
#else
#ifdef ANSI_INST
template class RangeMap<WideChar,UnivChar>;
#else
typedef RangeMap<WideChar,UnivChar> Dummy_92;
#endif
#endif
#ifdef __DECCXX
#pragma define_template SharedXcharMap<PackedBoolean>
#else
#ifdef ANSI_INST
template class SharedXcharMap<PackedBoolean>;
#else
typedef SharedXcharMap<PackedBoolean> Dummy_93;
#endif
#endif
#ifdef __DECCXX
#pragma define_template SharedXcharMap<unsigned char>
#else
#ifdef ANSI_INST
template class SharedXcharMap<unsigned char>;
#else
typedef SharedXcharMap<unsigned char> Dummy_94;
#endif
#endif
#ifdef __DECCXX
#pragma define_template String<Char>
#else
#ifdef ANSI_INST
template class String<Char>;
#else
typedef String<Char> Dummy_95;
#endif
#endif
#ifdef __DECCXX
#pragma define_template String<EquivCode>
#else
#ifdef ANSI_INST
template class String<EquivCode>;
#else
typedef String<EquivCode> Dummy_96;
#endif
#endif
#ifdef __DECCXX
#pragma define_template String<SyntaxChar>
#else
#ifdef ANSI_INST
template class String<SyntaxChar>;
#else
typedef String<SyntaxChar> Dummy_97;
#endif
#endif
#ifdef __DECCXX
#pragma define_template SubstTable<Char>
#else
#ifdef ANSI_INST
template class SubstTable<Char>;
#else
typedef SubstTable<Char> Dummy_98;
#endif
#endif
#ifdef __DECCXX
#pragma define_template VectorBase<RankStem*>
#else
#ifdef ANSI_INST
template class VectorBase<RankStem*>;
#else
typedef VectorBase<RankStem*> Dummy_99;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<RankStem*>
#else
#ifdef ANSI_INST
template class Vector<RankStem*>;
#else
typedef Vector<RankStem*> Dummy_100;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<const RankStem*>
#else
#ifdef ANSI_INST
template class Vector<const RankStem*>;
#else
typedef Vector<const RankStem*> Dummy_101;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<Attributed*>
#else
#ifdef ANSI_INST
template class Vector<Attributed*>;
#else
typedef Vector<Attributed*> Dummy_102;
#endif
#endif
#ifdef __DECCXX
#pragma define_template VectorBase<ElementType*>
#else
#ifdef ANSI_INST
template class VectorBase<ElementType*>;
#else
typedef VectorBase<ElementType*> Dummy_103;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<ElementType*>
#else
#ifdef ANSI_INST
template class Vector<ElementType*>;
#else
typedef Vector<ElementType*> Dummy_104;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<const ElementType*>
#else
#ifdef ANSI_INST
template class Vector<const ElementType*>;
#else
typedef Vector<const ElementType*> Dummy_105;
#endif
#endif
#ifdef __DECCXX
#pragma define_template VectorBase<String<Char> >
#else
#ifdef ANSI_INST
template class VectorBase<String<Char> >;
#else
typedef VectorBase<String<Char> > Dummy_106;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<String<Char> >
#else
#ifdef ANSI_INST
template class Vector<String<Char> >;
#else
typedef Vector<String<Char> > Dummy_107;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<String<EquivCode> >
#else
#ifdef ANSI_INST
template class Vector<String<EquivCode> >;
#else
typedef Vector<String<EquivCode> > Dummy_108;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<Owner<MessageArg> >
#else
#ifdef ANSI_INST
template class Vector<Owner<MessageArg> >;
#else
typedef Vector<Owner<MessageArg> > Dummy_109;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<char>
#else
#ifdef ANSI_INST
template class Vector<char>;
#else
typedef Vector<char> Dummy_110;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<Owner<ContentToken> >
#else
#ifdef ANSI_INST
template class Vector<Owner<ContentToken> >;
#else
typedef Vector<Owner<ContentToken> > Dummy_111;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<ConstResourcePointer<Entity> >
#else
#ifdef ANSI_INST
template class Vector<ConstResourcePointer<Entity> >;
#else
typedef Vector<ConstResourcePointer<Entity> > Dummy_112;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<Owner<AttributeDefinition> >
#else
#ifdef ANSI_INST
template class Vector<Owner<AttributeDefinition> >;
#else
typedef Vector<Owner<AttributeDefinition> > Dummy_113;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<unsigned int>
#else
#ifdef ANSI_INST
template class Vector<unsigned int>;
#else
typedef Vector<unsigned int> Dummy_114;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<size_t>
#else
#ifdef ANSI_INST
template class Vector<size_t>;
#else
typedef Vector<size_t> Dummy_115;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<ResourcePointer<NamedResource> >
#else
#ifdef ANSI_INST
template class Vector<ResourcePointer<NamedResource> >;
#else
typedef Vector<ResourcePointer<NamedResource> > Dummy_116;
#endif
#endif
#ifdef __DECCXX
#pragma define_template VectorBase<GrowableVector<LeafContentToken*> >
#else
#ifdef ANSI_INST
template class VectorBase<GrowableVector<LeafContentToken*> >;
#else
typedef VectorBase<GrowableVector<LeafContentToken*> > Dummy_117;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<GrowableVector<LeafContentToken*> >
#else
#ifdef ANSI_INST
template class Vector<GrowableVector<LeafContentToken*> >;
#else
typedef Vector<GrowableVector<LeafContentToken*> > Dummy_118;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<ConstResourcePointer<AttributeValue> >
#else
#ifdef ANSI_INST
template class Vector<ConstResourcePointer<AttributeValue> >;
#else
typedef Vector<ConstResourcePointer<AttributeValue> > Dummy_119;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<HashTableItemBase<String<Char> >*>
#else
#ifdef ANSI_INST
template class Vector<HashTableItemBase<String<Char> >*>;
#else
typedef Vector<HashTableItemBase<String<Char> >*> Dummy_120;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<Text>
#else
#ifdef ANSI_INST
template class Vector<Text>;
#else
typedef Vector<Text> Dummy_121;
#endif
#endif
#ifdef __DECCXX
#pragma define_template VectorBase<SrInfo>
#else
#ifdef ANSI_INST
template class VectorBase<SrInfo>;
#else
typedef VectorBase<SrInfo> Dummy_122;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<SrInfo>
#else
#ifdef ANSI_INST
template class Vector<SrInfo>;
#else
typedef Vector<SrInfo> Dummy_123;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<Named*>
#else
#ifdef ANSI_INST
template class Vector<Named*>;
#else
typedef Vector<Named*> Dummy_124;
#endif
#endif
#ifdef __DECCXX
#pragma define_template VectorBase<FirstSet>
#else
#ifdef ANSI_INST
template class VectorBase<FirstSet>;
#else
typedef VectorBase<FirstSet> Dummy_125;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<FirstSet>
#else
#ifdef ANSI_INST
template class Vector<FirstSet>;
#else
typedef Vector<FirstSet> Dummy_126;
#endif
#endif
#ifdef __DECCXX
#pragma define_template VectorBase<PackedBoolean>
#else
#ifdef ANSI_INST
template class VectorBase<PackedBoolean>;
#else
typedef VectorBase<PackedBoolean> Dummy_127;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<PackedBoolean>
#else
#ifdef ANSI_INST
template class Vector<PackedBoolean>;
#else
typedef Vector<PackedBoolean> Dummy_128;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<OpenElementInfo>
#else
#ifdef ANSI_INST
template class Vector<OpenElementInfo>;
#else
typedef Vector<OpenElementInfo> Dummy_129;
#endif
#endif
#ifdef __DECCXX
#pragma define_template XcharMap<PackedBoolean>
#else
#ifdef ANSI_INST
template class XcharMap<PackedBoolean>;
#else
typedef XcharMap<PackedBoolean> Dummy_130;
#endif
#endif
#ifdef __DECCXX
#pragma define_template XcharMap<unsigned char>
#else
#ifdef ANSI_INST
template class XcharMap<unsigned char>;
#else
typedef XcharMap<unsigned char> Dummy_131;
#endif
#endif

#ifdef __DECCXX
#pragma define_template NamedTable<Id>
#else
#ifdef ANSI_INST
template class NamedTable<Id>;
#else
typedef NamedTable<Id> Dummy_132;
#endif
#endif
#ifdef __DECCXX
#pragma define_template NamedTableIter<Id>
#else
#ifdef ANSI_INST
template class NamedTableIter<Id>;
#else
typedef NamedTableIter<Id> Dummy_133;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ResourcePointer<Dtd>
#else
#ifdef ANSI_INST
template class ResourcePointer<Dtd>;
#else
typedef ResourcePointer<Dtd> Dummy_134;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ResourcePointer<ElementDefinition>
#else
#ifdef ANSI_INST
template class ResourcePointer<ElementDefinition>;
#else
typedef ResourcePointer<ElementDefinition> Dummy_135;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ResourcePointer<Sd>
#else
#ifdef ANSI_INST
template class ResourcePointer<Sd>;
#else
typedef ResourcePointer<Sd> Dummy_136;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ResourcePointer<Syntax>
#else
#ifdef ANSI_INST
template class ResourcePointer<Syntax>;
#else
typedef ResourcePointer<Syntax> Dummy_137;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ISetIter<Char>
#else
#ifdef ANSI_INST
template class ISetIter<Char>;
#else
typedef ISetIter<Char> Dummy_138;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ISetIter<WideChar>
#else
#ifdef ANSI_INST
template class ISetIter<WideChar>;
#else
typedef ISetIter<WideChar> Dummy_139;
#endif
#endif
#ifdef __DECCXX
#pragma define_template IListIter<EquivClass>
#else
#ifdef ANSI_INST
template class IListIter<EquivClass>;
#else
typedef IListIter<EquivClass> Dummy_140;
#endif
#endif
#ifdef __DECCXX
#pragma define_template IListIter<InputSource>
#else
#ifdef ANSI_INST
template class IListIter<InputSource>;
#else
typedef IListIter<InputSource> Dummy_141;
#endif
#endif

#ifdef __DECCXX
#pragma define_template ResourcePointer<SourceLinkRuleResource>
#else
#ifdef ANSI_INST
template class ResourcePointer<SourceLinkRuleResource>;
#else
typedef ResourcePointer<SourceLinkRuleResource> Dummy_142;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ConstResourcePointer<SourceLinkRuleResource>
#else
#ifdef ANSI_INST
template class ConstResourcePointer<SourceLinkRuleResource>;
#else
typedef ConstResourcePointer<SourceLinkRuleResource> Dummy_143;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVectorD<IdLinkRule>
#else
#ifdef ANSI_INST
template class GrowableVectorD<IdLinkRule>;
#else
typedef GrowableVectorD<IdLinkRule> Dummy_144;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ConstResourcePointer<Lpd>
#else
#ifdef ANSI_INST
template class ConstResourcePointer<Lpd>;
#else
typedef ConstResourcePointer<Lpd> Dummy_145;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVectorD<ConstResourcePointer<SourceLinkRuleResource> >
#else
#ifdef ANSI_INST
template class GrowableVectorD<ConstResourcePointer<SourceLinkRuleResource> >;
#else
typedef GrowableVectorD<ConstResourcePointer<SourceLinkRuleResource> > Dummy_146;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<GrowableVectorD<ConstResourcePointer<SourceLinkRuleResource> > >
#else
#ifdef ANSI_INST
template class Vector<GrowableVectorD<ConstResourcePointer<SourceLinkRuleResource> > >;
#else
typedef Vector<GrowableVectorD<ConstResourcePointer<SourceLinkRuleResource> > > Dummy_147;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVectorD<ResultElementSpec>
#else
#ifdef ANSI_INST
template class GrowableVectorD<ResultElementSpec>;
#else
typedef GrowableVectorD<ResultElementSpec> Dummy_148;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<ConstResourcePointer<AttributeDefinitionList> >
#else
#ifdef ANSI_INST
template class Vector<ConstResourcePointer<AttributeDefinitionList> >;
#else
typedef Vector<ConstResourcePointer<AttributeDefinitionList> > Dummy_149;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVectorD<ConstResourcePointer<Lpd> >
#else
#ifdef ANSI_INST
template class GrowableVectorD<ConstResourcePointer<Lpd> >;
#else
typedef GrowableVectorD<ConstResourcePointer<Lpd> > Dummy_150;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<const EntitySet *>
#else
#ifdef ANSI_INST
template class Vector<const EntitySet *>;
#else
typedef Vector<const EntitySet *> Dummy_151;
#endif
#endif
#ifdef __DECCXX
#pragma define_template VectorBase<LpdEntityRef *>
#else
#ifdef ANSI_INST
template class VectorBase<LpdEntityRef *>;
#else
typedef VectorBase<LpdEntityRef *> Dummy_152;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<LpdEntityRef *>
#else
#ifdef ANSI_INST
template class Vector<LpdEntityRef *>;
#else
typedef Vector<LpdEntityRef *> Dummy_153;
#endif
#endif
#ifdef __DECCXX
#pragma define_template PointerTable<LpdEntityRef *, LpdEntityRef, LpdEntityRef, LpdEntityRef>
#else
#ifdef ANSI_INST
template class PointerTable<LpdEntityRef *, LpdEntityRef, LpdEntityRef, LpdEntityRef>;
#else
typedef PointerTable<LpdEntityRef *, LpdEntityRef, LpdEntityRef, LpdEntityRef> Dummy_154;
#endif
#endif
#ifdef __DECCXX
#pragma define_template PointerTableIter<LpdEntityRef *, LpdEntityRef, LpdEntityRef, LpdEntityRef>
#else
#ifdef ANSI_INST
template class PointerTableIter<LpdEntityRef *, LpdEntityRef, LpdEntityRef, LpdEntityRef>;
#else
typedef PointerTableIter<LpdEntityRef *, LpdEntityRef, LpdEntityRef, LpdEntityRef> Dummy_155;
#endif
#endif
#ifdef __DECCXX
#pragma define_template OwnerTable<LpdEntityRef, LpdEntityRef, LpdEntityRef, LpdEntityRef>
#else
#ifdef ANSI_INST
template class OwnerTable<LpdEntityRef, LpdEntityRef, LpdEntityRef, LpdEntityRef>;
#else
typedef OwnerTable<LpdEntityRef, LpdEntityRef, LpdEntityRef, LpdEntityRef> Dummy_156;
#endif
#endif
#ifdef __DECCXX
#pragma define_template OwnerTableIter<LpdEntityRef, LpdEntityRef, LpdEntityRef, LpdEntityRef>
#else
#ifdef ANSI_INST
template class OwnerTableIter<LpdEntityRef, LpdEntityRef, LpdEntityRef, LpdEntityRef>;
#else
typedef OwnerTableIter<LpdEntityRef, LpdEntityRef, LpdEntityRef, LpdEntityRef> Dummy_157;
#endif
#endif
#ifdef ANSI_INST
template void setAll(LpdEntityRef **, unsigned long, LpdEntityRef *);
#else
static
void  func_0 (LpdEntityRef ** arg1, unsigned long arg2, LpdEntityRef * arg3) {
(void)setAll(arg1, arg2, arg3);
}
#endif
#ifdef __DECCXX
#pragma define_template IList<LinkProcessOpenElement>
#else
#ifdef ANSI_INST
template class IList<LinkProcessOpenElement>;
#else
typedef IList<LinkProcessOpenElement> Dummy_158;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ConstResourcePointer<ComplexLpd>
#else
#ifdef ANSI_INST
template class ConstResourcePointer<ComplexLpd>;
#else
typedef ConstResourcePointer<ComplexLpd> Dummy_159;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<ConstResourcePointer<Lpd> >
#else
#ifdef ANSI_INST
template class Vector<ConstResourcePointer<Lpd> >;
#else
typedef Vector<ConstResourcePointer<Lpd> > Dummy_160;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVector<const AttributeList *>
#else
#ifdef ANSI_INST
template class GrowableVector<const AttributeList *>;
#else
typedef GrowableVector<const AttributeList *> Dummy_161;
#endif
#endif

#ifdef ANSI_INST
template void setAll(HashTableItemBase<String<Char> > **, unsigned long, HashTableItemBase<String<Char> > *);
#else
static
void  func_1 (HashTableItemBase<String<Char> > ** arg1, unsigned long arg2, HashTableItemBase<String<Char> > * arg3) {
(void)setAll(arg1, arg2, arg3);
}
#endif
#ifdef ANSI_INST
template void setAll(Named **, unsigned long, Named *);
#else
static
void  func_2 (Named ** arg1, unsigned long arg2, Named * arg3) {
(void)setAll(arg1, arg2, arg3);
}
#endif
#ifdef ANSI_INST
template void setAll(ResourcePointer<NamedResource> *, unsigned long, ResourcePointer<NamedResource>);
#else
static
void  func_3 (ResourcePointer<NamedResource> * arg1, unsigned long arg2, ResourcePointer<NamedResource> arg3) {
(void)setAll(arg1, arg2, arg3);
}
#endif
#ifdef ANSI_INST
template void setAll(String<Char> *, unsigned long, String<Char>);
#else
static
void  func_4 (String<Char> * arg1, unsigned long arg2, String<Char> arg3) {
(void)setAll(arg1, arg2, arg3);
}
#endif
#ifdef ANSI_INST
template void setAll(char *, unsigned long, char);
#else
static
void  func_5 (char * arg1, unsigned long arg2, char arg3) {
(void)setAll(arg1, arg2, arg3);
}
#endif
#ifdef ANSI_INST
template void setAll(unsigned int *, unsigned long, unsigned int);
#else
static
void  func_6 (unsigned int * arg1, unsigned long arg2, unsigned int arg3) {
(void)setAll(arg1, arg2, arg3);
}
#endif
#ifdef ANSI_INST
template void setAll(unsigned long *, unsigned long, unsigned long);
#else
static
void  func_7 (unsigned long * arg1, unsigned long arg2, unsigned long arg3) {
(void)setAll(arg1, arg2, arg3);
}
#endif
#ifdef HAVE_BOOL
#ifdef ANSI_INST
template void setAll(bool *, unsigned long, bool);
#else
static
void  func_8 (bool * arg1, unsigned long arg2, bool arg3) {
(void)setAll(arg1, arg2, arg3);
}
#endif
#endif

#endif /* MANUAL_INST */
