// Copyright (c) 1994 James Clark
// See the file COPYING for copying permission.

#ifdef __GNUG__
#ifndef MANUAL_INST
#define MANUAL_INST
#endif
#endif

#ifdef MANUAL_INST

#define DEFINE_TEMPLATES
#include "Owner.H"
#include "CopyOwner.H"
#include "Vector.H"
#include "CopyVector.H"
#include "GrowableVectorD.H"
#include "CopyGrowableVectorD.H"
#include "GrowableVector.H"
#include "ResourcePointer.H"
#include "IList.H"
#include "IQueue.H"
#include "ISet.H"
#include "List.H"
#include "OwnerTable.H"
#include "PointerTable.H"
#include "HashTable.H"
#include "HashTableItemBase.H"
#include "String.H"
#include "RangeMap.H"
#include "SubstTable.H"
#include "XcharMap.H"
#include "IListIter.H"
#include "ISetIter.H"
#include "ListIter.H"
#undef DEFINE_TEMPLATES

#include <stddef.h>
#include "Attribute.H"
#include "Attributed.H"
#include "CharsetDecl.H"
#include "ContentToken.H"
#include "Dtd.H"
#include "ElementType.H"
#include "Entity.H"
#include "EquivClass.H"
#include "Event.H"
#include "Hash.H"
#include "HashTable.H"
#include "HashTableItemBase.H"
#include "InputSource.H"
#include "LinkProcess.H"
#include "Lpd.H"
#include "LpdEntityRef.H"
#include "Location.H"
#include "MessageArg.H"
#include "NamedResourceTable.H"
#include "NamedResource.H"
#include "NamedTable.H"
#include "Named.H"
#include "NameToken.H"
#include "OpenElement.H"
#include "OutputState.H"
#include "Recognizer.H"
#include "Sd.H"
#include "SdFormalError.H"
#include "SrInfo.H"
#include "StringResource.H"
#include "Syntax.H"
#include "Text.H"
#include "Trie.H"
#include "Undo.H"
#include "Boolean.H"
#include "types.H"
#include "Id.H"
#include "setAll.H"


__instantiate(ConstResourcePointer<Notation>)
__instantiate(ConstResourcePointer<Recognizer>)
__instantiate(ConstResourcePointer<EntityOrigin>)
__instantiate(ConstResourcePointer<NamedResource>)
__instantiate(ResourcePointer<NamedResource>)
__instantiate(ConstResourcePointer<AttributeValue>)
__instantiate(ConstResourcePointer<ElementDefinition>)
__instantiate(ConstResourcePointer<AttributeDefinitionList>)
__instantiate(ConstResourcePointer<SharedXcharMap<PackedBoolean> >)
__instantiate(ConstResourcePointer<SharedXcharMap<unsigned char> >)
__instantiate(ConstResourcePointer<StringResource<Char> >)
__instantiate(ConstResourcePointer<Sd>)
__instantiate(ConstResourcePointer<Dtd>)
__instantiate(ConstResourcePointer<Entity>)
__instantiate(ConstResourcePointer<Origin>)
__instantiate(ConstResourcePointer<Syntax>)
__instantiate(CopyGrowableVectorD<Attribute>)
__instantiate(CopyGrowableVectorD<TextItem>)
__instantiate(CopyOwner<BlankTrie>)
__instantiate(CopyOwner<AttributeSpec>)
__instantiate(CopyOwner<AttributeSemantics>)
__instantiate(VectorBase<char>)
__instantiate(CopyVector<char>)
__instantiate(CopyVector<ConstResourcePointer<Entity> >)
__instantiate(CopyVector<PackedBoolean>)
__instantiate(GrowableVectorD<Attribute>)
__instantiate(GrowableVectorD<TextItem>)
__instantiate(GrowableVectorD<NameToken>)
__instantiate(GrowableVectorD<CharsetDeclRange>)
__instantiate(GrowableVectorD<String<Char> >)
__instantiate(GrowableVectorD<CharsetDeclSection>)
__instantiate(GrowableVectorD<Owner<ContentToken> >)
__instantiate(GrowableVectorD<ConstResourcePointer<Dtd> >)
__instantiate(GrowableVectorD<Owner<AttributeDefinition> >)
__instantiate(GrowableVectorD<Owner<AttributeList> >)
__instantiate(GrowableVectorD<ConstResourcePointer<ElementDefinition> >)
__instantiate(GrowableVectorD<Text>)
__instantiate(GrowableVector<ContentModelAmbiguity>)
__instantiate(GrowableVector<Transition>)
__instantiate(VectorBase<LeafContentToken*>)
__instantiate(GrowableVector<LeafContentToken*>)
__instantiate(VectorBase<ISetRange<Char> >)
__instantiate(GrowableVector<ISetRange<Char> >)
__instantiate(VectorBase<ISetRange<WideChar> >)
__instantiate(GrowableVector<ISetRange<WideChar> >)
__instantiate(GrowableVector<EntityOriginNamedCharRef>)
__instantiate(`GrowableVector<RangeMapRange<WideChar,UnivChar> >')
__instantiate(GrowableVector<size_t>)
__instantiate(GrowableVector<unsigned int>)
__instantiate(HashTableItemBase<String<Char> >)
__instantiate(`HashTableItem<String<Char>, int>')
__instantiate(`HashTable<String<Char>,int>')
__instantiate(`HashTableItem<String<Char>,Char>')
__instantiate(`HashTable<String<Char>,Char>')
__instantiate(IList<EquivClass>)
__instantiate(IList<InputSource>)
__instantiate(IList<OpenElement>)
__instantiate(IList<ElementEvent>)
__instantiate(IList<OutputStateLevel>)
__instantiate(IList<SdFormalError>)
__instantiate(IList<Undo>)
__instantiate(IQueue<MessageEvent>)
__instantiate(IQueue<Event>)
__instantiate(ISet<Char>)
__instantiate(ISet<WideChar>)
__instantiate(`OwnerTable<HashTableItemBase<String<Char> >,String<Char>,Hash,HashTableKeyFunction<String<Char> > >')
__instantiate(`OwnerTableIter<HashTableItemBase<String<Char> >, String<Char>, Hash, HashTableKeyFunction<String<Char> > >')
__instantiate(`OwnerTable<Named,String<Char>,Hash,NamedTableKeyFunction>')
__instantiate(`OwnerTableIter<Named,String<Char>,Hash,NamedTableKeyFunction>')
__instantiate(Owner<AndInfo>)
__instantiate(Owner<BlankTrie>)
__instantiate(Owner<EquivClass>)
__instantiate(Owner<MessageArg>)
__instantiate(Owner<ModelGroup>)
__instantiate(Owner<OpenElement>)
__instantiate(Owner<ContentToken>)
__instantiate(Owner<ExternalInfo>)
__instantiate(Owner<AttributeSpec>)
__instantiate(Owner<DeclaredValue>)
__instantiate(Owner<LeafContentToken>)
__instantiate(Owner<AttributeSemantics>)
__instantiate(Owner<CompiledModelGroup>)
__instantiate(Owner<AttributeDefinition>)
__instantiate(Owner<AttributeList>)
__instantiate(Owner<Trie>)
__instantiate(`PointerTableIter<Named*,String<Char>,Hash,NamedTableKeyFunction>')
__instantiate(`PointerTable<HashTableItemBase<String<Char> >*,String<Char>,Hash,HashTableKeyFunction<String<Char> > >')
__instantiate(`PointerTableIter<HashTableItemBase<String<Char> > *, String<Char>, Hash, HashTableKeyFunction<String<Char> > >')
__instantiate(`PointerTable<Named*,String<Char>,Hash,NamedTableKeyFunction>')
__instantiate(`PointerTable<ResourcePointer<NamedResource>,String<Char>,Hash,NamedResourceKeyFunction>')
__instantiate(`PointerTableIter<ResourcePointer<NamedResource>,String<Char>,Hash,NamedResourceKeyFunction>')
__instantiate(`RangeMapIter<WideChar,UnivChar>')
__instantiate(`RangeMap<WideChar,UnivChar>')
__instantiate(SharedXcharMap<PackedBoolean>)
__instantiate(SharedXcharMap<unsigned char>)
__instantiate(String<Char>)
__instantiate(String<EquivCode>)
__instantiate(String<SyntaxChar>)
__instantiate(SubstTable<Char>)
__instantiate(VectorBase<RankStem*>)
__instantiate(Vector<RankStem*>)
__instantiate(Vector<const RankStem*>)
__instantiate(Vector<Attributed*>)
__instantiate(VectorBase<ElementType*>)
__instantiate(Vector<ElementType*>)
__instantiate(Vector<const ElementType*>)
__instantiate(VectorBase<String<Char> >)
__instantiate(Vector<String<Char> >)
__instantiate(Vector<String<EquivCode> >)
__instantiate(Vector<Owner<MessageArg> >)
__instantiate(Vector<char>)
__instantiate(Vector<Owner<ContentToken> >)
__instantiate(Vector<ConstResourcePointer<Entity> >)
__instantiate(Vector<Owner<AttributeDefinition> >)
__instantiate(Vector<unsigned int>)
__instantiate(Vector<size_t>)
__instantiate(Vector<ResourcePointer<NamedResource> >)
__instantiate(VectorBase<GrowableVector<LeafContentToken*> >)
__instantiate(Vector<GrowableVector<LeafContentToken*> >)
__instantiate(Vector<ConstResourcePointer<AttributeValue> >)
__instantiate(Vector<HashTableItemBase<String<Char> >*>)
__instantiate(Vector<Text>)
__instantiate(VectorBase<SrInfo>)
__instantiate(Vector<SrInfo>)
__instantiate(Vector<Named*>)
__instantiate(VectorBase<FirstSet>)
__instantiate(Vector<FirstSet>)
__instantiate(VectorBase<PackedBoolean>)
__instantiate(Vector<PackedBoolean>)
__instantiate(Vector<OpenElementInfo>)
__instantiate(XcharMap<PackedBoolean>)
__instantiate(XcharMap<unsigned char>)

__instantiate(NamedTable<Id>)
__instantiate(NamedTableIter<Id>)
__instantiate(ResourcePointer<Dtd>)
__instantiate(ResourcePointer<ElementDefinition>)
__instantiate(ResourcePointer<Sd>)
__instantiate(ResourcePointer<Syntax>)
__instantiate(ISetIter<Char>)
__instantiate(ISetIter<WideChar>)
__instantiate(IListIter<EquivClass>)
__instantiate(IListIter<InputSource>)

__instantiate(ResourcePointer<SourceLinkRuleResource>)
__instantiate(ConstResourcePointer<SourceLinkRuleResource>)
__instantiate(GrowableVectorD<IdLinkRule>)
__instantiate(ConstResourcePointer<Lpd>)
__instantiate(GrowableVectorD<ConstResourcePointer<SourceLinkRuleResource> >)
__instantiate(Vector<GrowableVectorD<ConstResourcePointer<SourceLinkRuleResource> > >)
__instantiate(GrowableVectorD<ResultElementSpec>)
__instantiate(Vector<ConstResourcePointer<AttributeDefinitionList> >)
__instantiate(GrowableVectorD<ConstResourcePointer<Lpd> >)
__instantiate(Vector<const EntitySet *>)
__instantiate(VectorBase<LpdEntityRef *>)
__instantiate(Vector<LpdEntityRef *>)
__instantiate(`PointerTable<LpdEntityRef *, LpdEntityRef, LpdEntityRef, LpdEntityRef>')
__instantiate(`PointerTableIter<LpdEntityRef *, LpdEntityRef, LpdEntityRef, LpdEntityRef>')
__instantiate(`OwnerTable<LpdEntityRef, LpdEntityRef, LpdEntityRef, LpdEntityRef>')
__instantiate(`OwnerTableIter<LpdEntityRef, LpdEntityRef, LpdEntityRef, LpdEntityRef>')
__instantiate_func3(setAll, LpdEntityRef **, unsigned long, LpdEntityRef *)
__instantiate(IList<LinkProcessOpenElement>)
__instantiate(ConstResourcePointer<ComplexLpd>)
__instantiate(Vector<ConstResourcePointer<Lpd> >)
__instantiate(GrowableVector<const AttributeList *>)

__instantiate_func3(setAll, HashTableItemBase<String<Char> > **, unsigned long, HashTableItemBase<String<Char> > *) 
__instantiate_func3(setAll, Named **, unsigned long, Named *) 
__instantiate_func3(setAll, ResourcePointer<NamedResource> *, unsigned long, ResourcePointer<NamedResource>) 
__instantiate_func3(setAll, String<Char> *, unsigned long, String<Char>) 
__instantiate_func3(setAll, char *, unsigned long, char) 
__instantiate_func3(setAll, unsigned int *, unsigned long, unsigned int) 
__instantiate_func3(setAll, unsigned long *, unsigned long, unsigned long) 
#ifdef HAVE_BOOL
__instantiate_func3(setAll, bool *, unsigned long, bool)
#endif

#endif /* MANUAL_INST */
